# $Revision: 1.35 $, $Date: 2011/02/19 09:07:02 $
# TODO
# - consider renaming to jenkins http://en.wikipedia.org/wiki/Jenkins_(software)
# - build it from sources
#   https://hudson.dev.java.net/files/documents/2402/125619/hudson-1.280-src.zip
# - use system jars
%include	/usr/lib/rpm/macros.java
Summary:	Hudson Continuous Build Server
Name:		hudson
Version:	1.384
Release:	1
License:	MIT License
Group:		Networking/Daemons/Java/Servlets
# Check for new releases and URLs here: https://hudson.dev.java.net/servlets/ProjectRSS?type=news
Source0:	http://hudson-ci.org/download/war/%{version}/%{name}.war#/%{name}-%{version}.war
# Source0-md5:	65d1108eac802c284fdf4633bee3ef92
Source1:	%{name}-context.xml
Patch0:		%{name}-webxml.patch
URL:		https://hudson.dev.java.net/
BuildRequires:	jpackage-utils
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.546
Requires:	jpackage-utils
Requires:	jre-X11
Requires:	tomcat
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Hudson monitors executions of repeated jobs, such as building a
software project or jobs run by cron.

Among those things, current Hudson focuses on the following two jobs:
- Building/testing software projects continuously, just like
  CruiseControl or DamageControl. In a nutshell, Hudson provides an
  easy-to-use so-called continuous integration system, making it easier
  for developers to integrate changes to the project, and making it
  easier for users to obtain a fresh build. The automated, continoues
  build increases the productivity.
- Monitoring executions of externally-run jobs, such as cron jobs and
  procmail jobs, even those that are run on a remote machine. For
  example, with cron, all you receive is regular e-mails that capture
  the output, and it is up to you to look at them diligently and notice
  when it broke. Hudson keeps those outputs and makes it easy for you to
  notice when something is wrong.

%prep
%setup -qc
rm *.class
rm winstone.jar

%patch0 -p1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/%{name},%{_datadir}/%{name},%{_sharedstatedir}/%{name},%{_tomcatconfdir}}
mv WEB-INF/web.xml $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/web.xml
cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/tomcat-context.xml
ln -sf %{_sysconfdir}/%{name}/tomcat-context.xml $RPM_BUILD_ROOT%{_tomcatconfdir}/%{name}.xml
cp -a . $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -sf %{_sysconfdir}/%{name}/web.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/WEB-INF/web.xml

%postun
%tomcat_clear_cache %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%dir %{_sysconfdir}/%{name}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/*.xml
%{_tomcatconfdir}/%{name}.xml
%{_datadir}/%{name}
%attr(2775,root,servlet) %dir %{_sharedstatedir}/%{name}

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: hudson.spec,v $
Revision 1.35  2011/02/19 09:07:02  glen
- oss project renamed to jenkins on January 11, 2011

Revision 1.34  2010/11/15 13:32:33  pawelz
- up to 1.384

Revision 1.33  2010/09/07 14:48:19  pawelz
- rel 2

Revision 1.32  2010/09/07 14:47:10  pawelz
- use webxml.patch instead of installing own version of web.xml.

Revision 1.31  2010/08/31 13:59:05  pawelz
- up to 1.374

Revision 1.30  2010/07/20 10:07:44  pawelz
- up to 1.367
- fixes http://infradna.com/content/security-advisory-2010-07-05
- added version number to Source0 file name.

Revision 1.29  2010/06/10 11:40:15  pawelz
- up to 1.361

Revision 1.28  2010/03/25 19:31:20  glen
- you shall not package a directory with %config
- be consistent: use always name macro

Revision 1.27  2010/03/24 13:19:18  pawelz
- partially reverted previous commit
- rel 2

Revision 1.26  2010/03/24 13:14:02  pawelz
- use more macros!

Revision 1.25  2010/03/24 13:07:28  pawelz
- fix File listed twice: /etc/hudson/web.xml

Revision 1.24  2010/03/24 12:57:44  pawelz
- up to 1.352

Revision 1.23  2010/03/24 12:47:11  pawelz
- install tomcat context configuration into /etc/hudson and symlink it to %{_tomcatconfdir}
- use all these new cool tomcat-related macros
- clear tomcat cache in %postun
- require tomcat and new rpm macros

Revision 1.22  2009/12/16 11:34:54  pawelz
- up to 1.337
- R: jre-X11 (because of fonts. Reported by Witek Wołejszo <ww (at) touk (dot) pl>, thx)

Revision 1.21  2009/11/26 15:45:34  pawelz
- up to 1.335, dedicated to _zork_

Revision 1.20  2009/09/22 08:55:03  pawelz
- up to 1.324

Revision 1.19  2009/08/12 11:11:42  pawelz
- up to 1.319

Revision 1.18  2009/05/27 09:09:41  pawelz
- up to 1.307

Revision 1.17  2009/05/13 09:47:33  pawelz
- up to 1.304

Revision 1.16  2009/04/23 15:52:09  pawelz
- up to 1.300
- G: Networking/Daemons/Java/Servlets
- do not install embedded servlet container, we deploy it into tomcat
- rel 1

Revision 1.15  2009/04/12 15:17:51  glen
- todo

Revision 1.14  2009/04/12 15:10:20  pawelz
- drop stupid R: java-servlet-container
- R: group(servlet)
- chmod 2775, chgrp servlet for /var/lib/hudson

Revision 1.13  2009/03/16 15:02:56  pawelz
- up to 1.292

Revision 1.12  2009/02/27 11:42:18  pawelz
- up to 286

Revision 1.11  2009/02/27 11:22:33  pawelz
- require any java-servlet-container

Revision 1.10  2009/02/02 15:18:40  pawelz
- once again md5. Is it correct now?

Revision 1.9  2009/02/02 15:05:53  pawelz
- md5

Revision 1.8  2009/02/02 15:04:16  pawelz
- up to 1.280

Revision 1.7  2009/02/01 23:27:52  pawelz
- do not be so tomcat-centric. Use /usr/share/hudson instead of
  /usr/share/tomcat/webapps/hudson
- not tested. Please backup you /var/lib/hudson befor upgrading!

Revision 1.6  2009/01/26 10:56:24  pawelz
- require apache-tomcat version that uses tomcat uid/gid

Revision 1.5  2009/01/26 10:52:44  pawelz
- use tomcat uid/gid

Revision 1.4  2009/01/26 10:03:52  glen
- use dot rather asterisk for smaller build log ;)

Revision 1.3  2009/01/26 09:05:16  pawelz
- deploy hudson in tomcat
- is this a correct way to package .war apps? Please comment. It works
  out-of-the-box. If you have apache-tomcat installed, you can just
  rpm -ivh hudson and it works.

Revision 1.2  2009/01/26 07:50:11  pawelz
- up to 1.278

Revision 1.1  2008/12/29 11:02:14  glen
- new, just skeleton
